SystemOrganization addCategory: #'ObjectSheet-Core'!
SystemOrganization addCategory: #'ObjectSheet-Morph'!
SystemOrganization addCategory: #'ObjectSheet-Morph-cell'!
SystemOrganization addCategory: #'ObjectSheet-Morphic'!

!String methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 17:33'!
objectSheetCellMorphContents
	^self! !

!String methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 17:33'!
objectSheetCellMorphWidthIn: anObjectSheetMorph
	^(anObjectSheetMorph defaultCellFont widthOfStringOrText: self) + 20! !

!True methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:04'!
themeSmallIcon
	^ThemeIcons smallOkIcon! !

!Text methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 14:03'!
objectSheetCellMorphContents
	^self! !

!Text methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:42'!
objectSheetCellMorphWidthIn: anObjectSheetMorph
	^(anObjectSheetMorph defaultCellFont widthOfStringOrText: self) + 20! !

!False methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:03'!
themeSmallIcon
	^ThemeIcons smallCancelIcon! !

!Morph methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 14:03'!
objectSheetCellMorphContents
	^self! !

!Morph methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:22'!
objectSheetCellMorphWidthIn: anObjectSheetMorph
	^self width! !

!Morph methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/21/2013 10:52'!
objectSheetReadOnlyCellMorphClass
	^OSMorphCellMorph! !

Morph subclass: #OSCellMorph
	instanceVariableNames: 'cell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

!OSCellMorph methodsFor: 'accessing' stamp: 'HwaJong 4/7/2013 06:44'!
cell
	^ cell! !

!OSCellMorph methodsFor: 'accessing' stamp: 'HwaJong 4/7/2013 06:44'!
cell: aOSCell
	cell := aOSCell! !

!OSCellMorph methodsFor: 'accessing' stamp: 'HwaJong 5/16/2013 04:05'!
contents: anObject
	self subclassResponsibility! !

OSCellMorph subclass: #OSCheckboxMorph
	instanceVariableNames: 'checkboxMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

!OSCheckboxMorph methodsFor: 'accessing' stamp: 'HwaJong 5/16/2013 05:00'!
contents: aBoolean 
	checkboxMorph extent: self extent.
	self changed: #isCheckboxSelected.! !

!OSCheckboxMorph methodsFor: 'accessing' stamp: 'HwaJong 5/15/2013 23:24'!
font: aStrikeFont 
	^self! !

!OSCheckboxMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/16/2013 04:18'!
initialize
	super initialize.
	self color: Color white.
	checkboxMorph := UITheme builder newCheckboxFor: self getSelected: #isCheckboxSelected setSelected: #isCheckboxSelected: label: '' help: nil.
	
	self addMorph: checkboxMorph.
	checkboxMorph hResizing: #spaceFill.
	checkboxMorph vResizing: #spaceFill.
	checkboxMorph extent: self extent! !

!OSCheckboxMorph methodsFor: 'accessing' stamp: 'HwaJong 5/16/2013 04:59'!
isCheckboxSelected
	^cell isNil
		ifTrue: [false]
		ifFalse: [cell cell cellObject]! !

!OSCheckboxMorph methodsFor: 'accessing' stamp: 'HwaJong 5/16/2013 05:09'!
isCheckboxSelected: aBoolean
	cell cell cellObject: aBoolean.
	"self changed: #isCheckboxSelected."
	cell sheetMorph updateCells.! !

OSCellMorph subclass: #OSEditableTextCellMorph
	instanceVariableNames: 'textFieldMorph selectionInterval hasUnacceptedEdits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/21/2013 17:48'!
accept
	cell beAcceptedByEditableTextCellMorph: self.
	cell sheetMorph updateCells.! !

!OSEditableTextCellMorph methodsFor: 'accessing' stamp: 'HwaJong 4/21/2013 17:45'!
contents
	^textFieldMorph contents! !

!OSEditableTextCellMorph methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 12:12'!
contents: aString 
	textFieldMorph contents: aString.
	textFieldMorph wrapFlag: true.
	textFieldMorph center: self center.
	textFieldMorph extent: self extent -2! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2013 06:36'!
editor
	^textFieldMorph! !

!OSEditableTextCellMorph methodsFor: 'accessing' stamp: 'HwaJong 4/6/2013 23:43'!
font: aStrikeFont 
	"textFieldMorph font: aStrikeFont"! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2013 06:43'!
handleFocusEvent: anEvent
	^true! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2013 23:53'!
hasUnacceptedEdits: aBoolean 
	hasUnacceptedEdits := aBoolean ! !

!OSEditableTextCellMorph methodsFor: 'initialize' stamp: 'HwaJong 4/13/2013 12:10'!
initialize
	super initialize.
	self color: Color white.
	textFieldMorph := TextMorphForEditView new.
	textFieldMorph acceptOnCR: true.
	textFieldMorph acceptOnFocusChange: true.
	textFieldMorph autoFit: true.
	textFieldMorph wrapFlag: true.
	textFieldMorph setEditView: self.
	self addMorph: textFieldMorph.
	textFieldMorph hResizing: #spaceFill.
	textFieldMorph vResizing: #spaceFill.! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2013 23:52'!
mouseDownFromTextMorph: aMouseButtonEvent 
	"self shouldBeImplemented."
	^self! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2013 23:54'!
scrollByKeyboard: aKeyboardEvent 
	^false! !

!OSEditableTextCellMorph methodsFor: 'initialize' stamp: 'HwaJong 4/21/2013 17:12'!
scrollSelectionIntoView
	^self! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/13/2013 12:07'!
scrollSelectionIntoView: aMouseMoveEvent 
	^self! !

!OSEditableTextCellMorph methodsFor: 'accessing' stamp: 'HwaJong 4/6/2013 23:51'!
selectionInterval: anInterval 
	selectionInterval := anInterval! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2013 23:54'!
setScrollDeltas
	^self! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2013 06:33'!
takesKeyboardFocus
	^true! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2013 23:55'!
textChanged
	^self ! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2013 23:34'!
textOfTextFieldMorph
	^'head bang'! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2013 06:29'!
wantsKeyboardFocus
	^true! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2013 06:40'!
wantsKeyboardFocusNavigation
	^true! !

!OSEditableTextCellMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2013 06:30'!
wouldAcceptKeyboardFocusUponTab
	^true! !

OSCellMorph subclass: #OSMorphCellMorph
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

!OSMorphCellMorph methodsFor: 'accessing' stamp: 'HwaJong 3/14/2013 12:19'!
contents: aMorph
	morph := aMorph.
	aMorph extent: (aMorph extent min: self extent).
	self addMorph: aMorph.
	morph center: self center.! !

!OSMorphCellMorph methodsFor: 'accessing' stamp: 'HwaJong 4/20/2013 21:26'!
font: aFont
	! !

!OSMorphCellMorph methodsFor: 'initialize' stamp: 'HwaJong 3/14/2013 11:19'!
initialize
	super initialize.
	self color: Color white.! !

OSCellMorph subclass: #OSTextCellMorph
	instanceVariableNames: 'labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

OSTextCellMorph subclass: #OSHeaderCellMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

!OSHeaderCellMorph methodsFor: 'accessing' stamp: 'HwaJong 3/14/2013 11:10'!
contents: aString
	super contents: aString asText allBold! !

!OSHeaderCellMorph methodsFor: 'initialize' stamp: 'HwaJong 3/14/2013 11:08'!
initialize 
	super initialize.
	self color: (Color gray: 0.7).! !

!OSTextCellMorph methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 14:11'!
contents: aString 
	labelMorph contents: aString.
	labelMorph center: self center.! !

!OSTextCellMorph methodsFor: 'accessing' stamp: 'HwaJong 3/14/2013 00:53'!
font: aStrikeFont 
	labelMorph font: aStrikeFont! !

!OSTextCellMorph methodsFor: 'initialize' stamp: 'HwaJong 3/14/2013 00:54'!
initialize
	super initialize.
	self color: Color white.
	labelMorph := LabelMorph new.
	self addMorph: labelMorph.
	labelMorph hResizing: #spaceFill.
	labelMorph vResizing: #spaceFill.! !

!Boolean methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 14:03'!
objectSheetCellMorphContents
	^(self themeSmallIcon) asMorph! !

!Boolean methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:20'!
objectSheetCellMorphWidthIn:  anObjectSheetMorph
	^self themeSmallIcon width! !

!Boolean methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/21/2013 10:52'!
objectSheetReadOnlyCellMorphClass
	^OSMorphCellMorph! !

Object subclass: #ModelForPluggableMultiColumnListMorphOnObjectSheet
	instanceVariableNames: 'objectSheet selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morphic'!

!ModelForPluggableMultiColumnListMorphOnObjectSheet methodsFor: 'defaults' stamp: 'HwaJong 3/13/2013 21:52'!
defaultSelectionIndex
	^0! !

!ModelForPluggableMultiColumnListMorphOnObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 17:12'!
objectSheet
	^objectSheet! !

!ModelForPluggableMultiColumnListMorphOnObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 17:12'!
objectSheet: anObjectSheet
	objectSheet := anObjectSheet! !

!ModelForPluggableMultiColumnListMorphOnObjectSheet methodsFor: 'widget' stamp: 'HwaJong 3/13/2013 21:52'!
selectionIndex
	^selectionIndex setDefault: #defaultSelectionIndex for: self withSetter: #selectionIndex:! !

!ModelForPluggableMultiColumnListMorphOnObjectSheet methodsFor: 'widget' stamp: 'HwaJong 3/13/2013 21:51'!
selectionIndex: anInteger 
	selectionIndex := anInteger.
	self changed: #selectionIndex! !

!ModelForPluggableMultiColumnListMorphOnObjectSheet methodsFor: 'widget' stamp: 'HwaJong 3/13/2013 21:52'!
stringsForMutliColumnListMorph
	^objectSheet rows 
		collect: [:ro| 
			objectSheet columns asArray 
				collect: [:co| (co getAspectValueOf: ro) printString]]! !

Object subclass: #OSCell
	instanceVariableNames: 'rowObject column objectSheet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Core'!

!OSCell methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2013 21:41'!
cellObject
	^column getAspectValueOf: rowObject! !

!OSCell methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2013 00:03'!
cellObject: anObject 
	column writeAspect value: rowObject objectSheetObject value: anObject! !

!OSCell methodsFor: 'accessing' stamp: 'HwaJong 4/7/2013 06:50'!
column
	^ column! !

!OSCell methodsFor: 'accessing' stamp: 'HwaJong 4/6/2013 21:40'!
column: anOSEditableColumn 
	column := anOSEditableColumn! !

!OSCell methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2013 06:00'!
columnIndex
	^self objectSheet columns indexOf: column! !

!OSCell methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/13/2013 15:21'!
objectSheet
	^objectSheet! !

!OSCell methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 15:21'!
objectSheet: anObjectSheet 
	objectSheet := anObjectSheet! !

!OSCell methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2013 06:01'!
rowIndex
	^self objectSheet rows indexOf: rowObject! !

!OSCell methodsFor: 'accessing' stamp: 'HwaJong 4/6/2013 21:41'!
rowObject: anOSRow 
	rowObject := anOSRow! !

Object subclass: #OSColumn
	instanceVariableNames: 'name aspect writeAspect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Core'!

!OSColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:03'!
aspect
	^ aspect! !

!OSColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:03'!
aspect: anObject
	aspect := anObject! !

!OSColumn methodsFor: 'evaluating' stamp: 'HwaJong 4/13/2013 14:05'!
getAspectValueOf: anObject
	|op|
	op := [aspect value: anObject objectSheetObject ] .
	^op
		on: Error do: [:exp| 
			|button|
			button := SimpleButtonMorph new.
			button label: 'debug'.
			button color: (Color r: 1 g: 0.6 b: 0.6).
			button target: op.
			button actionSelector: #value.
			button]! !

!OSColumn methodsFor: 'testing' stamp: 'HwaJong 4/13/2013 14:17'!
isEditable
	^writeAspect notNil ! !

!OSColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:03'!
name
	^ name
! !

!OSColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:03'!
name: anObject
	name := anObject! !

!OSColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:03'!
writeAspect
	^ writeAspect! !

!OSColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:03'!
writeAspect: anObject
	writeAspect := anObject! !

Object subclass: #OSMorphifyColumn
	instanceVariableNames: 'column morphContentSetter morphContentGetter objectSheetMorph cellMorphClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

!OSMorphifyColumn methodsFor: 'accessing' stamp: 'HwaJong 4/21/2013 10:46'!
cellMorphClass
	^ cellMorphClass! !

!OSMorphifyColumn methodsFor: 'accessing' stamp: 'HwaJong 4/21/2013 10:46'!
cellMorphClass: aClass
	cellMorphClass := aClass! !

!OSMorphifyColumn methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/21/2013 11:49'!
cellMorphClassFor: anObject 

	^self cellMorphClass 
		ifNil:
			[self isEditable
				ifTrue: [ anObject objectSheetReadWriteCellMorphClass ]
				ifFalse: [ anObject objectSheetReadOnlyCellMorphClass ]]
		ifNotNil: [:thatClass| thatClass ].! !

!OSMorphifyColumn methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/21/2013 16:03'!
cellObjects
	^objectSheetMorph sheetModel cellObjectsOfColumn: column ! !

!OSMorphifyColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:04'!
column
	^ column! !

!OSMorphifyColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:04'!
column: anObject
	column := anObject! !

!OSMorphifyColumn methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/21/2013 16:40'!
headerPixelWidth
	^(column name asText allBold) objectSheetCellMorphWidthIn: objectSheetMorph! !

!OSMorphifyColumn methodsFor: 'testing' stamp: 'HwaJong 4/13/2013 14:18'!
isEditable
	^column isEditable! !

!OSMorphifyColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:04'!
morphContentGetter
	^ morphContentGetter! !

!OSMorphifyColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:04'!
morphContentGetter: anObject
	morphContentGetter := anObject! !

!OSMorphifyColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:04'!
morphContentSetter
	^ morphContentSetter! !

!OSMorphifyColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:04'!
morphContentSetter: anObject
	morphContentSetter := anObject! !

!OSMorphifyColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:40'!
objectSheetMorph
	^objectSheetMorph! !

!OSMorphifyColumn methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:40'!
objectSheetMorph: aObjectSheetMorph
	objectSheetMorph := aObjectSheetMorph! !

!OSMorphifyColumn methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/21/2013 16:56'!
pixelWidthsOfCells
	^(self cellObjects)
		collect: [ :object |  object objectSheetCellMorphWidthIn: objectSheetMorph ].! !

!OSMorphifyColumn methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/21/2013 16:56'!
widthOfColumn
	^(self pixelWidthsOfCells , {self headerPixelWidth}) max max: 50.! !

Object subclass: #OSMorphifyableCell
	instanceVariableNames: 'cell sheetMorph morphifyColumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

!OSMorphifyableCell methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/15/2013 23:04'!
beAcceptedByEditableTextCellMorph: anOSEditableTextCellMorph 
	cell cellObject:
		(morphifyColumn morphContentSetter
			ifNil: [(Compiler evaluate: anOSEditableTextCellMorph contents)]
			ifNotNil: [:setter| setter value: anOSEditableTextCellMorph ])! !

!OSMorphifyableCell methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/15/2013 22:15'!
boundsForCellMorph
	^(sheetMorph waffle) 
		boundsOfIndentationAtRow: (cell rowIndex+1) 
		atColumn: (cell columnIndex+sheetMorph columnOffsetByRowHeader)! !

!OSMorphifyableCell methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 15:08'!
cell
	^ cell! !

!OSMorphifyableCell methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 15:08'!
cell: anOSCell
	cell := anOSCell! !

!OSMorphifyableCell methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/16/2013 18:25'!
cellMorph
	|object morph|
	object := cell cellObject.
		
	morph := 
		((morphifyColumn cellMorphClassFor: object) new)
			bounds: (self boundsForCellMorph);
			font: (sheetMorph defaultCellFont);
			cell: self;
			yourself.

	morph contents: 
		((morphifyColumn morphContentGetter
			ifNil: [ [:o| o objectSheetCellMorphContents ] ]
			ifNotNil: [ morphifyColumn morphContentGetter ]) value: object).
	^morph.! !

!OSMorphifyableCell methodsFor: 'accessing' stamp: 'HwaJong 4/21/2013 13:21'!
cellObject: anObject 
	cell cellObject: anObject! !

!OSMorphifyableCell methodsFor: 'accessing' stamp: 'HwaJong 4/21/2013 10:08'!
morphifyColumn
	^ morphifyColumn! !

!OSMorphifyableCell methodsFor: 'accessing' stamp: 'HwaJong 4/21/2013 10:05'!
morphifyColumn: anOSMorphifiableColumn
	morphifyColumn := anOSMorphifiableColumn.
	cell column: anOSMorphifiableColumn column.! !

!OSMorphifyableCell methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 15:08'!
sheetMorph
	^ sheetMorph! !

!OSMorphifyableCell methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 15:09'!
sheetMorph: anObjectSheetMorph
	sheetMorph := anObjectSheetMorph! !

Object subclass: #OSRow
	instanceVariableNames: 'name object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Core'!

!OSRow methodsFor: 'accessing' stamp: 'HwaJong 3/5/2013 11:12'!
name
	^name! !

!OSRow methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:47'!
name: aString 
	name := aString! !

!OSRow methodsFor: 'accessing' stamp: 'HwaJong 3/5/2013 11:07'!
object
	^ object! !

!OSRow methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:47'!
object: anObject 
	object := anObject! !

!OSRow methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 18:06'!
objectSheetObject
	^self object! !

Object subclass: #OSUpdatingMethod
	instanceVariableNames: 'objectSheetMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph'!

OSUpdatingMethod subclass: #OSNullUpdate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph'!

!OSNullUpdate methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2013 15:46'!
updateObjectSheetMorphBy: aSymbol 
	"i do nothing"
	^self! !

OSUpdatingMethod subclass: #OSReceiveRowsToUpdate
	instanceVariableNames: 'updateSelector model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph'!

!OSReceiveRowsToUpdate methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 17:43'!
model: anObject
	model := anObject! !

!OSReceiveRowsToUpdate methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2013 17:09'!
updateObjectSheetMorphBy: aSymbol 
	aSymbol = updateSelector 
		ifTrue: 
			[objectSheetMorph sheetModel rows: nil.
			(model perform: aSymbol) do: [:each| objectSheetMorph sheetModel addRowWithObject: each].
			objectSheetMorph updateCells]	! !

!OSReceiveRowsToUpdate methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:53'!
updateSelector: aSymbol 
	updateSelector := aSymbol ! !

OSUpdatingMethod subclass: #OSSelfUpdate
	instanceVariableNames: 'updateSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph'!

!OSSelfUpdate methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2013 15:49'!
updateObjectSheetMorphBy: aSymbol 
	updateSelector = aSymbol
		ifTrue: [objectSheetMorph updateCells] ! !

!OSSelfUpdate methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:48'!
updateSelector
	^updateSelector! !

!OSSelfUpdate methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:48'!
updateSelector: aSymbol
	updateSelector := aSymbol! !

!OSUpdatingMethod class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2013 15:43'!
newForObjectSheetMorph: anObjectSheetMorph
	^self new objectSheetMorph: anObjectSheetMorph! !

!OSUpdatingMethod methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:50'!
objectSheetMorph: anObjectSheetMoprh
	objectSheetMorph := anObjectSheetMoprh.! !

!Object methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 14:03'!
objectSheetCellMorphContents
	^self printString! !

!Object methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:24'!
objectSheetCellMorphWidthIn: anObjectSheetMorph
	^(anObjectSheetMorph defaultCellFont widthOfStringOrText: self asString) + 20! !

!Object methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/13/2013 18:07'!
objectSheetObject
	^self! !

!Object methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/21/2013 10:52'!
objectSheetReadOnlyCellMorphClass
	^OSTextCellMorph! !

!Object methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/21/2013 10:54'!
objectSheetReadWriteCellMorphClass
	^OSEditableTextCellMorph! !

Object subclass: #ObjectSheet
	instanceVariableNames: 'name columns rows cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Core'!

!ObjectSheet methodsFor: 'adding' stamp: 'HwaJong 4/21/2013 14:07'!
addColumn: aString aspect: blockOrSymbol
	self columns addLast: (OSColumn new name: aString; aspect: blockOrSymbol)! !

!ObjectSheet methodsFor: 'adding' stamp: 'HwaJong 4/21/2013 14:07'!
addColumnWithAspectSymbol: aSymbol
	self columns addLast: (OSColumn new name: aSymbol asString; aspect: aSymbol)! !

!ObjectSheet methodsFor: 'adding' stamp: 'HwaJong 4/21/2013 14:07'!
addEditableColumn: aString readAspect: blockOrSymbol1 writeAspect: blockOrSymbol2 
	self columns addLast: (OSColumn new name: aString; aspect: blockOrSymbol1; writeAspect: blockOrSymbol2)! !

!ObjectSheet methodsFor: 'adding' stamp: 'HwaJong 3/4/2013 10:46'!
addRow: aString object: anObject 
	self rows addLast: (OSRow new name: aString; object: anObject)! !

!ObjectSheet methodsFor: 'adding' stamp: 'HwaJong 3/14/2013 18:41'!
addRowWithObject: anObject 
	self addRow: anObject printString object: anObject! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 18:09'!
cellObjectAtRow: anInteger atColumn: anInteger2 
	^(columns at: anInteger2) getAspectValueOf: (rows at: anInteger).! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/5/2013 11:15'!
cellObjectAtRowName: string1 atColumnName: string2 
	^(self columnNamed: string2) aspect value: (self rowNamed: string1) object.! !

!ObjectSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/21/2013 16:04'!
cellObjectsOfColumn: anOSColumn 
	^self cellObjectsOfColumnAtIndex: (columns indexOf: anOSColumn) ! !

!ObjectSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/21/2013 16:05'!
cellObjectsOfColumnAtIndex: anInteger 
	^(1 to: self rows size) collect: [ :rowIndex | self cellObjectAtRow: rowIndex atColumn: anInteger ]! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/5/2013 11:15'!
columnNamed: aString 
	^columns detect: [:each| each name = aString]! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:44'!
columns

	^columns setDefault: #defaultColumns for: self withSetter: #columns:! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:44'!
columns: anObject
		
	columns := anObject! !

!ObjectSheet methodsFor: 'defaults' stamp: 'HwaJong 3/4/2013 10:44'!
defaultColumns

	"Return a default object for instance variable columns."
	^OrderedCollection new! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/14/2013 11:54'!
defaultName
	^'ObjectSheet'! !

!ObjectSheet methodsFor: 'defaults' stamp: 'HwaJong 3/4/2013 10:47'!
defaultRows

	"Return a default object for instance variable rows."
	^OrderedCollection new! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/14/2013 11:59'!
name
	^name setDefault: #defaultName for: self withSetter: #name:! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:41'!
name: aString 
	name := aString! !

!ObjectSheet methodsFor: 'display' stamp: 'HwaJong 4/21/2013 10:12'!
openInWindowWithRowHeaders
	^self openInWindowWithRowHeaders: true.! !

!ObjectSheet methodsFor: 'display' stamp: 'HwaJong 4/21/2013 10:13'!
openInWindowWithRowHeaders: aBoolean 
	|morph window|
	morph := ObjectSheetMorph new.
	morph treatsFirstColumnAsRowHeaderAspect: aBoolean.
	morph sheetModel: self.
	window := morph openInWindowLabeled: self name.
	morph createThings.
	morph extent: morph extent.
	^window! !

!ObjectSheet methodsFor: 'display' stamp: 'HwaJong 5/16/2013 18:37'!
openInWindowWithoutRowHeaders
	^self openInWindowWithRowHeaders: false.! !

!ObjectSheet methodsFor: 'display' stamp: 'HwaJong 4/2/2013 15:13'!
openMorphWithRowHeaders: aBoolean
	|morph|
	morph := ObjectSheetMorph new.
	morph treatsFirstColumnAsRowHeaderAspect: aBoolean.
	morph sheetModel: self.
	morph createThings.
	morph setExtentOfBigMorphs.
	^morph! !

!ObjectSheet methodsFor: 'display' stamp: 'HwaJong 3/14/2013 11:21'!
openWithRowHeaders
	^self openWithRowHeaders: true.! !

!ObjectSheet methodsFor: 'display' stamp: 'HwaJong 3/13/2013 22:07'!
openWithRowHeaders: aBoolean
	|morph|
	morph := ObjectSheetMorph new.
	morph treatsFirstColumnAsRowHeaderAspect: aBoolean.
	morph sheetModel: self.
	morph openInWindowLabeled: self name.
	morph createThings.
	morph extent: morph extent.
	^morph! !

!ObjectSheet methodsFor: 'display' stamp: 'HwaJong 3/13/2013 22:07'!
openWithoutRowHeaders
	^self openWithRowHeaders: false.! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/5/2013 11:12'!
rowNamed: aString 
	^rows detect: [:each| each name = aString]! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:47'!
rows

	^rows setDefault: #defaultRows for: self withSetter: #rows:! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 19:35'!
rows: aSequenceableCollection
		
	rows := aSequenceableCollection! !

ScrollPane subclass: #ObjectSheetMorph
	instanceVariableNames: 'waffle sheetModel bigMorph treatsFirstColumnAsRowHeaderAspect updateMethod morphifyColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph'!

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 4/21/2013 10:18'!
booleanIconsWorkspace
|sh|
sh := ObjectSheet new.
sh name: 'boolean operations'.
sh addColumn: 'bool1' aspect: [:arr| arr at: 1].
sh addColumn: 'bool2' aspect: [:arr| arr at: 2].
sh addColumn: 'and' aspect: [:arr| (arr at: 1) and: [arr at: 2]].
sh addColumn: 'or' aspect: [:arr| (arr at: 1) or: [arr at: 2]].
sh addColumn: 'xor' aspect: [:arr| (arr at: 1) xor: [arr at: 2]].
{{false. false}. {false. true}. {true. false}. {true. true}} 
	do: [:m| sh addRow: m printString object: m].
sh openInWindowWithRowHeaders extent: 450@200.! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 5/16/2013 18:48'!
colorMorphWorkspace
|sh|
sh := ObjectSheet new.
sh addColumn: 'color' aspect: [:color| Morph new color: color].
sh addColumn: 'printString' aspect: #yourself.
sh addColumnWithAspectSymbol: #red.
sh addColumnWithAspectSymbol: #green.
sh addColumnWithAspectSymbol: #blue.
sh addColumnWithAspectSymbol: #printHtmlString.
(Color colorNames collect: [:string| Color perform: string]) do: [:color| sh addRowWithObject: color ].
sh openInWindowWithoutRowHeaders extent: (909@390).! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 5/16/2013 18:24'!
editableBooleanIconsWorkspace
|sh morph window|
sh := ObjectSheet new.
sh name: 'boolean operations'.
sh addEditableColumn: 'bool1' readAspect: [:arr| arr at: 1] writeAspect: [:arr :newVal | arr at: 1 put: newVal ].
sh addEditableColumn: 'bool1' readAspect: [:arr| arr at: 2] writeAspect: [:arr :newVal | arr at: 2 put: newVal ].
sh addColumn: 'and' aspect: [:arr| (arr at: 1) and: [arr at: 2]].
sh addColumn: 'or' aspect: [:arr| (arr at: 1) or: [arr at: 2]].
sh addColumn: 'xor' aspect: [:arr| (arr at: 1) xor: [arr at: 2]].
{{false. false}. {false. true}. {true. false}. {true. true}} 
	do: [:m| sh addRow: m printString object: m].
	
morph := ObjectSheetMorph new.
morph treatsFirstColumnAsRowHeaderAspect: true.
morph sheetModel: sh.
(morph morphifyColumns at: 1)
	cellMorphClass: OSCheckboxMorph;
	morphContentGetter: [ :o|  o ].
(morph morphifyColumns at: 2)
	cellMorphClass: OSCheckboxMorph;
	morphContentGetter: [ :o|  o ].
window := morph openInWindow.
window extent: 450@200.! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 4/21/2013 13:17'!
editableSumWorkspace
|sh|
sh := ObjectSheet new.
sh addEditableColumn: 'first' readAspect: [:obj| obj at: 1] writeAspect: [:obj :newVal| obj at: 1 put: newVal].
sh addEditableColumn: 'second' readAspect: [:obj| obj at: 2] writeAspect: [:obj :newVal| obj at: 2 put: newVal].
sh addRowWithObject: {1. 2}.
sh addRowWithObject: {3. 4}.
sh addRowWithObject: {5. 6}.
sh addRowWithObject: {7. 8}.
sh addColumnWithAspectSymbol: #sum.
sh openInWindowWithRowHeaders extent: 300@200.! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 3/14/2013 19:15'!
errorWorkspace
|sh|
sh := ObjectSheet new.
sh name: 'exception handling'.
sh addColumn: 'sqrt' aspect: #sqrt.
sh addColumn: 'factorial' aspect: #factorial.
sh addColumn: 'size' aspect: #size.
sh addColumn: 'asUppercase' aspect: #asUppercase.
sh addRowWithObject: 4. 
sh addRowWithObject: 'hello buddy'.
sh openWithRowHeaders.! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 4/21/2013 16:55'!
firstColumnReadOnlySumWorkspace
|sh morph window|
sh := ObjectSheet new.
sh addEditableColumn: 'first' readAspect: [:obj| obj at: 1] writeAspect: [:obj :newVal| obj at: 1 put: newVal].
sh addEditableColumn: 'second' readAspect: [:obj| obj at: 2] writeAspect: [:obj :newVal| obj at: 2 put: newVal].
sh addRowWithObject: {1. 2}.
sh addRowWithObject: {3. 4}.
sh addRowWithObject: {5. 6}.
sh addRowWithObject: {7. 8}.
sh addColumnWithAspectSymbol: #sum.

morph := ObjectSheetMorph new.
morph treatsFirstColumnAsRowHeaderAspect: true.
morph sheetModel: sh.
(morph morphifyColumns at: 1) cellMorphClass: OSTextCellMorph.
window := morph openInWindow.
window extent: 300@200.! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 5/16/2013 18:34'!
instVarUsageWorkspace
|subject sh|
subject := OSMorphifyColumn.
sh := ObjectSheet new.
sh name: subject name.
subject instVarNames do: [:str| sh addColumn: str 
		aspect: 
			[:method| |varIndex| 
			varIndex := subject instVarNames indexOf: str.
			(method readsField: varIndex) or: (method writesField: varIndex)] ].
(subject selectors asSortedCollection) do: [:sym| sh addRow: sym object: (subject compiledMethodAt: sym) ].
sh openWithRowHeaders.

! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 5/16/2013 18:23'!
morphContentGetterOnSumWorkspace
|sh morph window|
sh := ObjectSheet new.
sh addEditableColumn: 'first' readAspect: [:obj| obj at: 1] writeAspect: [:obj :newVal| obj at: 1 put: newVal].
sh addEditableColumn: 'second' readAspect: [:obj| obj at: 2] writeAspect: [:obj :newVal| obj at: 2 put: newVal].
sh addRowWithObject: {1. 2}.
sh addRowWithObject: {3. 4}.
sh addRowWithObject: {5. 6}.
sh addRowWithObject: {7. 8}.
sh addColumnWithAspectSymbol: #sum.

morph := ObjectSheetMorph new.
morph treatsFirstColumnAsRowHeaderAspect: true.
morph sheetModel: sh.
(morph morphifyColumns at: 1)
	cellMorphClass: OSTextCellMorph;
	morphContentGetter: [ :o| '777' ].
window := morph openInWindow.
window extent: 300@200.! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 5/15/2013 23:11'!
morphContentSetterOnSumWorkspace
|sh morph window|
sh := ObjectSheet new.
sh addEditableColumn: 'first' readAspect: [:obj| obj at: 1] writeAspect: [:obj :newVal| obj at: 1 put: newVal].
sh addEditableColumn: 'second' readAspect: [:obj| obj at: 2] writeAspect: [:obj :newVal| obj at: 2 put: newVal].
sh addRowWithObject: {1. 2}.
sh addRowWithObject: {3. 4}.
sh addRowWithObject: {5. 6}.
sh addRowWithObject: {7. 8}.
sh addColumnWithAspectSymbol: #sum.

morph := ObjectSheetMorph new.
morph treatsFirstColumnAsRowHeaderAspect: true.
morph sheetModel: sh.
(morph morphifyColumns at: 1)
	morphContentSetter: [:m| 56 ].
window := morph openInWindow.
window extent: 300@200.! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 5/16/2013 18:51'!
multiColumnListMorphWorkspace
|sh mo li|
sh := ObjectSheet new.
sh name: 'boolean operations'.
sh addColumn: 'bool1' aspect: [:arr| arr at: 1].
sh addColumn: 'bool2' aspect: [:arr| arr at: 2].
sh addColumn: 'and' aspect: [:arr| (arr at: 1) and: [arr at: 2]].
sh addColumn: 'or' aspect: [:arr| (arr at: 1) or: [arr at: 2]].
sh addColumn: 'xor' aspect: [:arr| (arr at: 1) xor: [arr at: 2]].
{{false. false}. {false. true}. {true. false}. {true. true}} 
	do: [:m| sh addRow: m printString object: m].

mo := ModelForPluggableMultiColumnListMorphOnObjectSheet new objectSheet: sh.

li := PluggableMultiColumnListMorph on: mo list: #stringsForMutliColumnListMorph selected: #selectionIndex changeSelected: #selectionIndex: menu: nil wrapSelector: #yourself.
(li openInWindowLabeled: 'pluggable list') extent: (255@131)! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 4/21/2013 10:20'!
oneCellWorkspace
|sh|
sh := ObjectSheet new.
sh addColumn: 'first' aspect: [:obj| obj at: 1].
sh addRowWithObject: {1. 2}.
sh openInWindowWithRowHeaders. ! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 3/14/2013 11:22'!
salaryWorkspace
|dailyCharge constants os|
dailyCharge := ObjectSheet new
	name: 'daily charge';
	addColumn: 'unit price' aspect: #value;
	addRow: 'weekday' object: 23;
	addRow: 'sat, sun, holi' object: 25;
	addRow: 'event alpha' object: 30.


constants := ObjectSheet new
	name: 'constants';
	addColumn: 'value' aspect: #yourself;
	addRow: 'weeks per month' object: 4.


os := ObjectSheet new
	name: 'salary case study';
	addColumn: 'weekdays worked per week' aspect: [:arr| arr at: 1];
	addColumn: 'freedays worked per week' aspect: [:arr| arr at: 2];
	addColumn: 'events in month' aspect: [:arr| arr at: 3];
	addColumn: 'salary' aspect: [:arr| 
		((arr first * (dailyCharge cellObjectAtRowName: 'weekday' atColumnName: 'unit price')) +
		(arr second * (dailyCharge cellObjectAtRowName: 'sat, sun, holi' atColumnName: 'unit price'))) * (constants cellObjectAtRowName: 'weeks per month' atColumnName: 'value') +
		(arr third * (dailyCharge cellObjectAtRowName: 'event alpha' atColumnName: 'unit price'))];
	addRow: '2 weekdays per week' object: {2. 0. 0};
	addRow: '5 weekdays per week' object: {5. 0. 0};
	addRow: '2 weekdays per week + 1 event day' object: {2. 0. 1};
	addRow: '5 weekdays per week + 1 event day' object: {5. 0. 1};
	addRow: 'all month' object: {5. 2. 0};
	addRow: 'all month + 1 event day' object: {5. 2. 1}.

os openWithRowHeaders.
dailyCharge openWithRowHeaders.
constants openWithRowHeaders.

! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 4/21/2013 11:07'!
testingWorkspace
|samples os|
samples := {true. World. 'hello'. Text string: 'red color text' attribute: TextColor red. Smalltalk}.

os := ObjectSheet new
	addColumnWithAspectSymbol: #class;
	addColumnWithAspectSymbol: #hash;
	addColumnWithAspectSymbol: #size;
	addColumn: 'color' aspect: [:m| Morph new color: m color].

samples do: [:each| os addRowWithObject: each].
os openInWindowWithRowHeaders extent: (658@216).! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 3/13/2013 21:42'!
addRowHeaderSegmentsToWaffle
	self treatsFirstColumnAsRowHeaderAspect
		ifTrue: 
			[waffle addFixedColumnSegment: self widthOfRowHeader.
			waffle addFixedColumnSegment: 1].! !

!ObjectSheetMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/21/2013 16:36'!
cellObjectOfColumnHeaderForColumn: anOSColumn 
	^(sheetModel columns indexOf: anOSColumn) shouldBeImplemented! !

!ObjectSheetMorph methodsFor: 'self evaluating' stamp: 'HwaJong 3/13/2013 21:43'!
columnOffsetByRowHeader
	^self treatsFirstColumnAsRowHeaderAspect
		ifTrue: [1]
		ifFalse: [0]! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 3/14/2013 00:11'!
createBigMorph
	|contentExtent|
	contentExtent := waffle columnSegments sumOfLengthOfFixedSegments @ waffle rowSegments sumOfLengthOfFixedSegments.
	bigMorph := Morph new extent: contentExtent; color: (Color gray: 0.8).
	waffle bounds: (0@0 extent: contentExtent).
	self scroller addMorph: bigMorph.
! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 4/21/2013 14:17'!
createCells
	(1 to: sheetModel rows size) do: [:rowIndex|
		(1 to: sheetModel columns size) do: [:columnIndex| 
			bigMorph addMorph: 
				((OSMorphifyableCell new 
					cell: (OSCell new 
						rowObject: (sheetModel rows at: rowIndex);
						objectSheet: sheetModel); 
					sheetMorph: self; 
					morphifyColumn: (self morphifyColumns at: columnIndex)) cellMorph) ]].! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 3/14/2013 11:11'!
createColumnHeaders
	sheetModel columns keysAndValuesDo: [:key :column|
		bigMorph addMorph: 
			(OSHeaderCellMorph new
				font: self defaultCellFont;
				bounds: (waffle boundsOfIndentationAtRow: 1 atColumn: key+self columnOffsetByRowHeader);
				contents: column name)]! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 3/14/2013 11:10'!
createRowHeaders
	self treatsFirstColumnAsRowHeaderAspect
		ifTrue: 
			[sheetModel rows keysAndValuesDo: [:key :row|
				bigMorph addMorph: 
					(OSHeaderCellMorph new
						font: self defaultCellFont;
						bounds: (waffle boundsOfIndentationAtRow: key+1 atColumn: 1);
						contents: row name)]]! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 4/21/2013 14:20'!
createThings
	self createWaffle.
	self createBigMorph.
	self createCells.
	self createRowHeaders.
	self createColumnHeaders.! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 4/21/2013 16:46'!
createWaffle
	waffle := WFWaffleLayout new.
	waffle addFixedColumnSegment: 2.
	self addRowHeaderSegmentsToWaffle.
	(self morphifyColumns) 
		do: [:mColumn|
			waffle addFixedColumnSegment: (mColumn widthOfColumn)] 
		separatedBy: [waffle addFixedColumnSegment: 1].	
	
	waffle addFixedColumnSegment: 2.

	waffle addFixedRowSegment: 2.
	waffle addFixedRowSegment: self heightOfColumnHeader.
	waffle addFixedRowSegment: 1.
	(1 to: sheetModel rows size) 
		do: [:key|
			waffle addFixedRowSegment: (self heightOfRowAtIndex: key)]
		separatedBy: [waffle addFixedRowSegment: 1].
	waffle addFixedRowSegment: 2.! !

!ObjectSheetMorph methodsFor: 'fonts' stamp: 'HwaJong 3/14/2013 00:05'!
defaultCellFont
	^StandardFonts defaultFont! !

!ObjectSheetMorph methodsFor: 'defaults' stamp: 'HwaJong 4/21/2013 17:05'!
defaultMorphifyColumns

	^sheetModel columns 
		collect: 
			[:each| 
			OSMorphifyColumn new 
				column: each; 
				objectSheetMorph: self]! !

!ObjectSheetMorph methodsFor: 'defaults' stamp: 'HwaJong 3/13/2013 21:47'!
defaultTreatsFirstColumnAsRowHeaderAspect
	^true! !

!ObjectSheetMorph methodsFor: 'defaults' stamp: 'HwaJong 4/2/2013 15:46'!
defaultUpdateMethod
	^OSNullUpdate newForObjectSheetMorph: sheetModel! !

!ObjectSheetMorph methodsFor: 'geo1 - height' stamp: 'HwaJong 3/13/2013 21:29'!
heightOfColumnHeader
	^25! !

!ObjectSheetMorph methodsFor: 'geo1 - height' stamp: 'HwaJong 3/13/2013 21:29'!
heightOfRowAtIndex: anInteger
	^25! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 4/21/2013 14:18'!
morphifyColumns
	morphifyColumns 
		ifNotNil: 
			[morphifyColumns size = sheetModel columns size ifFalse: [self morphifyColumns: nil].].
	^morphifyColumns setDefault: #defaultMorphifyColumns for: self withSetter: #morphifyColumns:! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 4/13/2013 14:11'!
morphifyColumns: anObject
		
	morphifyColumns := anObject! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 4/21/2013 16:54'!
openInWindow
	|window|
	window := self openInWindowLabeled: sheetModel name.
	self createThings.
	self extent: self extent.
	^window! !

!ObjectSheetMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2013 15:20'!
setExtentOfBigMorphs
	self extent: bigMorph extent + 10! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:57'!
sheetModel
	^sheetModel! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 21:29'!
sheetModel: anObjectSheet
	sheetModel := anObjectSheet! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 21:46'!
treatsFirstColumnAsRowHeaderAspect
	^treatsFirstColumnAsRowHeaderAspect setDefault: #defaultTreatsFirstColumnAsRowHeaderAspect for: self withSetter: #treatsFirstColumnAsRowHeaderAspect:! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 21:46'!
treatsFirstColumnAsRowHeaderAspect: aBoolean
	treatsFirstColumnAsRowHeaderAspect := aBoolean! !

!ObjectSheetMorph methodsFor: 'updating' stamp: 'HwaJong 4/2/2013 17:15'!
update: aSymbol
	self updateMethod updateObjectSheetMorphBy: aSymbol! !

!ObjectSheetMorph methodsFor: 'updating' stamp: 'HwaJong 4/3/2013 03:29'!
updateCells
	bigMorph delete.
	self createThings.! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:40'!
updateMethod
	^ updateMethod setDefault: #defaultUpdateMethod for: self withSetter: #updateMethod:! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:39'!
updateMethod: anOSUpdatingMethod
	updateMethod := anOSUpdatingMethod! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 4/6/2013 21:49'!
waffle
	^ waffle! !

!ObjectSheetMorph methodsFor: 'geo1 - width' stamp: 'HwaJong 4/6/2013 19:09'!
widthOfRowHeader
	^((sheetModel rows collect: [:each| self defaultCellFont widthOfStringOrText: each name asText allBold]) inject: 30 into: [:max :each| max max: each]) + 20! !
